Our API is based on HTTP requests and supports both HTTP and HTTPS protocols.
API endpoints:
https://ocr.tenet.com/in.php is used to submit a captcha
https://ocr.tenet.com/res.php is used to get the captcha solution
NEW For image captcha, now you can use https://ocr.tenet.com/solve.php instead of in.php to directly get the results.
The process of solving captchas with tenet is really easy and it's mostly the same for all types of captchas:
Get your API key from your API key. Each user is given a unique authentication token, we call it API key. It's a 32-characters string that looks like: 347bc2896fc1812d3de5ab56a0bf4ea7
This key will be used for all your requests to our server.
Submit a HTTP POST request to our API URL:
https://ocr.tenet.com/in.php with parameters corresponding to the type of your captcha.
Server will return captcha ID or an error code if
something went wrong.
Make a timeout: 20 seconds for reCAPTCHA, 5 seconds for other types of captchas.
Submit a HTTP GET request to our API URL:https://ocr.tenet.com/res.php to get the result.
If captcha is already solved server will return the answer in format corresponding to the type of your captcha.
By default answers are returned as plain text like: OK|Your answer. But answer can also be returned as JSON {"status":1,"request":"TEXT"} if json parameter is used.
If captcha is not solved yet server will return CAPCHA_NOT_READY result. Repeat your request in 5 seconds.
If something went wrong server will return an error code.
Normal Captcha
Normal Captcha is an image that contains distored but human-readable text. To solve the captcha user have to type the text from the image.
To solve the captcha with our service you have to submit the image with HTTP POST
request to our API URL: https://ocr.tenet.com/in.php
Server accepts images in multipart or base64 format.
NEW For image captcha, now you can use https://ocr.tenet.com/solve.php instead of in.php to directly get the results.
You can provide additional parameters with your request to define what kind of captcha you'resending and to help OCR servers to solve your captcha correctly. You can find the full list of parameters in the table below.
If everything is fine server will return the ID of your captcha as plain text, like:OK|123456789 or as JSON {"status":1,"request":"123456789"} if json parameter was used.
If something went wrong server will return an error. See Error Handling chapter for the list of errors.
Make a 5 seconds timeout and submit a HTTP GET request to our API URL: https://ocr.tenet.com/res.php providing the captcha ID. The list of parameters is in the table below.
If everything is fine and your captcha is solved server will return the answer as plain text, like: OK|TEXT or as JSON {"status":1,"request":"TEXT"} if json parameter was used.
Otherwise server will return CAPCHA_NOT_READY that means that your captcha is not solved yet. Just repeat your request in 5 seconds.
If something went wrong server will return an error. See Error Handling chapter for the list of errors.
List of POST request parameters for https://ocr.tenet.com/in.php
0 - captcha contains one word 1 - captcha contains two or more words
regsense
Integer Default: 0
No
0 - captcha in not case sensitive 1 - captcha is case sensitive
numeric
Integer Default: 0
No
0 - not specified 1 - captcha contains only numbers 2 - captcha contains only letters 3 - captcha contains only numbers OR only letters 4 - captcha contains both numbers AND letters
calc
Integer Default: 0
No
0 - not specified 1 - captcha requires calculation (e.g. type the result 4 + 8 = )
min_len
Integer Default: 0
No
0 - not specified 1..20 - minimal number of symbols in captcha
max_len
Integer Default: 0
No
0 - not specified 1..20 - maximal number of symbols in captcha
language
Integer Default: 0
No
0 - not specified 1 - Cyrillic captcha 2 - Latin captcha
0 - server will send the response as plain text 1 - tells the server to send the response as JSON
header_acao
Integer Default: 0
No
0 - disabled 1 - enabled. If enabled res.php will include Access-Control-Allow-Origin:* header in the response. Used for cross-domain AJAX requests in web applications.
reCAPTCHA V2 also known as I'm not a robot reCAPTCHA is a very popular type of captcha that looks like this:
Solving reCAPTCHA V2 with our method is pretty simple:
Look at the element's code at the page where you found reCAPTCHA.
Find a link that begins with [www.google.com/recaptcha/api2/anchor](https://www.google.com/recaptcha/api2/anchor) or find data-sitekey parameter.
Copy the value of k parameter of the link (or value of data-sitekey parameter).
Submit a HTTP GET or POST request to our API URL: https://ocr.tenet.com/in.php with method set to userrecaptcha and the value found on previous step as value for googlekey and full page URL as value for pageurl. Sending proxies is not obligatory ar the moment but it's recommended. You can find the full list of parameters in the table below.
If everything is fine server will return the ID of your captcha as plain text, like:
OK|123456789 or as JSON {"status":1,"request":"123456789"} if
json parameter was used.
Otherwise server will return an error code.
Make a 15-20 seconds timeout then submit a HTTP GET request to our API URL:
https://ocr.tenet.com/res.php to get the result.
The full list of parameters is in the table below.
If captcha is already solved server will respond in plain text or JSON and return the
answer token that looks like:
If captcha is not solved yet server will return CAPCHA_NOT_READY result. Repeat your request in 5 seconds.
If something went wrong server will return an error code.
Locate the element with id g-recaptcha-response and make it visible deleting display:none parameter.
Please note: sometimes content on the page is generated dynamically and you will not see this element in html source. In such cases you have to explore javascript code that generates the content. "Inspect" option in Google Chrome can help in that.
As an alternative you can just use javascript to set the value of g-recaptcha-response field:
Invisible reCAPTCHA is located on a DIV layer positioned -10 000 px from top that makes it invisible for user.
reCAPTCHA is activated on page load or on user's actions like click somewhere or submit a form - that depends on the website. If user's cookies are good enough then he will just pass it utomatically and no additional actions will be required. Otherwise user will see standard eCAPTCHA form with a challenge.
In most cases when challenge is completed a callback function is executed. You can read more about callback here.
If you are still not sure — there are few ways to determine that reCAPTCHA is in invisible mode:
You don't see "I'm not a robot" checkbox on the page but getting recaptcha challenge making some actions there
reCAPTCHA's iframe link contains parameter size=invisible
reCAPTCHA's configuration object contains parameter size that is set to invisible, for example ___grecaptcha_cfg.clients[0].aa.l.size is equal to invisible
How to bypass invisible reCAPTCHA in browser?
Method 1: using javascript:
Change the value of g-recaptcha-response element to the token you received from our server:
Execute the action that needs to be performed on the page after solving reCAPTCHA.
Usually there's a form that should be submitted and you need to identify the form by id or name or any other attribute and then submit the form. Here are few examples:
document.getElementById("recaptcha-demo-form").submit(); //by id "recaptcha-demo-form"
document.getElementsByName("myFormName")[0].submit(); //by element name "myFormName"
document.getElementsByClassName("example").submit(); //by class name "example"
Or sometimes there's a callback function executed when reCAPTCHA is solved.
Callback function is usually defined in data-callback parameter of reCAPTCHA, for example:
data-callback="myCallbackFunction"
Or sometimes it's defined as callback parameter of
grecaptcha.render function, for example:
userrecaptcha - defines that you're sending a reCAPTCHA V2 with new method
googlekey
String
Yes
Value of k or data-sitekey parameter you found on page
pageurl
String
Yes
Full URL of the page where you see the reCAPTCHA
domain
String Default: google.com
No
Domain used to load the captcha: google.com or recaptcha.net
invisible
Integer Default: 0
No
1 - means that reCAPTCHA is invisible. 0 - normal reCAPTCHA.
data-s
String
No
Value of data-s parameter you found on page. Curenttly applicable for Google Search and other Google services.
cookies
String
No
Your cookies that will be passed to our OCR server who solve the captha. We also return OCR server's cookies in the response if you use json=1. Format: KEY:Value, separator: semicolon, example: KEY1:Value1;KEY2:Value2;
userAgent
String
No
Your userAgent that will be passed to our OCR server and used to solve the captcha.
header_acao
Integer Default: 0
No
0 - disabled 1 - enabled. If enabled in.php will include Access-Control-Allow-Origin:* header in the response. Used for cross-domain AJAX requests in web applications. Also supported by res.php.
json
Integer Default: 0
No
0 - server will send the response as plain text 1 - tells the server to send the response as JSON
proxy
String
No
Format: login:email.com:3128 You can find more info about proxies here.
proxytype
String
No
Type of your proxy: HTTP, HTTPS, SOCKS4, SOCKS5.
List of GET request parameters for https://ocr.tenet.com/res.php
reCAPTCHA V3 is the newest type of captcha from Google. It has no challenge so there is no need for user interaction. Instead it uses a "humanity" rating - score.
reCAPTCHA V3 technically is quite similar to reCAPTCHA V2: customer receives a token from
reCAPTCHA API which is then sent inside a POST request to the target website and
verified via reCAPTCHA API.
The difference is now reCAPTCHA API returns rating of a user detecting whether he was a real human or a bot. This rating is called score and could be a number from 0.1 to 0.9. his score is passed to the website which then decides what to do with the user request.
Also there is a new parameter action allowing to process user actions on the website differently. After the verification of token reCAPTCHA API returns the name of the action user performed.
How to solve reCAPTCHA V3 using tenet:
First you've got to be sure the target website is actually using reCAPTCHA V3
There should be V3 if:
there is no captcha and no images to click on
api.js script is loading with the render=sitekey parameter, for example: https://www.google.com/recaptcha/api.js?render=6LfZil0UAAAAAAdm1Dpzsw9q0F11-bmervx9g5fE
clients array of ___grecaptcha_cfg object is using index 100000: ___grecaptcha_cfg.clients[100000]
To start solving reCAPTCHA V3 using our API first you've got to find three
parameters:
sitekey - this parameter could be obtained from the URI of
api.js as a value of render parameter. It could also be found inside
URI of iframe with reCAPTCHA, in javascript code of the website where it's
calling grecaptcha.execute function or in ___grecaptcha_cfg configuration
object.
action - you've got to find this inspecting javascript code of the website looking for call of grecaptcha.execute function. Example:
grecaptcha.execute('6LfZil0UAAAAAAdm1Dpzsw9q0F11-bmervx9g5fE', {action:
do_something}). Sometimes it's really hard to find it and you've got to dig through all js-files loaded by website. You may also try to find the value of action parameter inside___grecaptcha_cfg configuration object but usually it's undefined. In that case you have to call grecaptcha.execute and inspect javascript code. If you can't find it try to use the default value "verify" - our API will use it if you don't provide action in your request.
pageurl - full URL of the page where you see the reCAPTCHA V3.
Now you need to understand the score you need to solve V3. You can't
predict what score is acceptable for the website you want to solve at. It can
only be figured out by trial and error. The lowest score is 0.1 which means
"robot", the highest is 0.9 which means "human". But most sites uses thresholds
from 0.2 to 0.5 because real humans receive a low score oftenly. Our service is
able to provide solutions which requires the score of 0.3. Higher score is
extreamly rare.
Having all necessary parameters stated above you may send request to our API.
Submit a HTTP GET or POST request to our API URL:
https://ocr.tenet.com/in.php with method set to
userrecaptcha and version set to v3 along with
min_score set to score website requires, sitekey inside
googlekey parameter and full page URL as value for pageurl.
You have to include action parameter to or else we will use default
value verify.
If everything is fine server will return the ID of your captcha as plain text,like: OK|123456789 or as JSON
{"status":1,"request":"123456789"} if json parameter was used.
If something went wrong server will return an error. See Error Handling chapter for the list of errors.
Make a 10-15 seconds timeout and submit a HTTP GET request to our API
https://ocr.tenet.com/res.php providing the captcha ID. The list of parameters is in the table below.
If everything is fine and your captcha is solved server will return the answer as plain text or as JSON. The answer is a token like this:
After receiving the token from our API you've got to use it properly on the
target website. Best way to understant that is to check the requests sent to
site when you act as a normal user. Most browsers has developer's console tool
where you should check Network tab.
Usually token is sent using POST request. It could be g-recaptcha-response just like reCAPTCHA V2 does or g-recaptcha-response-100000. It could be other parameter too. So you'vegot to inspect the requests and find out how exactly the token supposed to be sent. Then you have to compose your request accordingly.
List of GET/POST request parameters for https://ocr.tenet.com/in.php
userrecaptcha — defines that you're sending a reCAPTCHA
version
String
Yes
v3 — defines that you're sending a reCAPTCHA V3
googlekey
String
Yes
Value of sitekey parameter you found on page
pageurl
String
Yes
Full URL of the page where you see the reCAPTCHA
domain
String Default: google.com
No
Domain used to load the captcha: google.com or recaptcha.net
action
String Default: verify
No
Value of action parameter you found on page
min_score
Integer Default: 0.4
No
The score needed for resolution. Currently it's almost impossible to get
token with score higher than 0.3
header_acao
Integer Default: 0
No
0 — disabled 1 — enabled. If enabled in.php will include Access-Control-Allow-Origin:* header in the
response. Used for cross-domain AJAX requests in web applications. Also supported by
res.php.
json
Integer Default: 0
No
0 — server will send the response as plain text 1 — tells the server to send the response as JSON
List of GET request parameters for https://ocr.tenet.com/res.php
get — get the asnwer for your captcha reportgood — report the asnwer was accepted reportbad — report the asnwer was declined
id
Integer
Yes
ID of captcha returned by in.php.
json
Integer Default: 0
No
0 — server will send the response as plain text 1 — tells the server to send the response as JSON
header_acao
Integer Default: 0
No
0 — disabled 1 — enabled. If enabled res.php will include Access-Control-Allow-Origin:* header in the response.
Used for cross-domain AJAX requests in web applications.
Details
Get details about your account and threads.
Submit a HTTP GET or POST request to our API URL: https://ocr.tenet.com/res.php with one of the following actions:
Proxy allows to solve the captcha from the same IP address as you load the page.
Using proxies is not obligatory in most cases. But for some kind of protection you should use it. For example: Cloudflare and Datadome protection pages require IP matching.
Proxies are not supported for reCAPTCHA V3 as proxies dramatically decrease the success rate for this types of captcha.
If you send us the proxy, we check it's availability trying to open the website through you proxy, and if we can't do that we will not use your proxy. If we're able to use your proxy - we'll load the reCAPTCHA through it for solving.
We support the following proxy types: SOCKS4, SOCKS5, HTTP, HTTPS with authentication by IP address or login and password.
If your proxy uses login/password authentication you have to include your credentials in proxy parameter.
POST parameters for proxies
POST parameter
Type
Required
Description
proxy
String
No
Format for IP authentication: IP_address:PORT Example:
proxy=123.123.123.123:3128
Format for login/password authentication:
login:password@IP_address:PORT
Example: proxy=proxyuser:email.com:3128
proxytype
String
No
Type of your proxy: HTTP, HTTPS, SOCKS4, SOCKS5.
Example: proxytype=SOCKS4
Cookies
Our API provides extended Cookies support for reCAPTCHA V2.
You can provide your cookies using the format below as the value of json_cookies parameter. We will set the cookies on our OCR server's browser.
After the captcha was solved succesfully, we will return all the cookies set for domains: google.com and the domain of your target website from pageurl parameter value.
You should use json=1 parameter in your request to res.php endpoint to get the
cookies.
Errors can be returned as plain text or as JSON if you provided json=1 parameter.
In very rare cases server can return HTML page with error text like 500 or 502 - please keep it in mind and handle such cases correctly. If you received anything that doesn't looks like the answer or error code - make a 5 seconds timeout and then retry your request.
List of in.php errors
Error code
Description
Action
ERROR_WRONG_USER_KEY
You've provided key parameter value in incorrect format, it should contain 32 symbols.
Server can't get file data from your POST-request. That happens if your POST-request is malformed or base64 data is not a valid base64 image.
You got to fix your code that makes POST request.
IP_BANNED
Your IP address is banned due to many frequent attempts to access the server using wrong authorization keys.
Ban will be automatically lifted after 5 minutes.
ERROR_BAD_TOKEN_OR_PAGEURL
You can get this error code when sending reCAPTCHA V2. That happens if your
request contains invalid pair of googlekey and pageurl. The common reason for
that is that reCAPTCHA is loaded inside an iframe hosted on another
domain/subdomain.
Explore code of the page carefully to find valid pageurl and sitekey values.
ERROR_GOOGLEKEY
You can get this error code when sending reCAPTCHA V2. That means that sitekey value provided in your request is incorrect: it's blank or malformed.
Check your code that gets the sitekey and makes requests to our API.
ERROR_WRONG_GOOGLEKEY
googlekey parameter is missing in your request
Check your code that gets the sitekey and makes requests to our API.
ERROR_CAPTCHAIMAGE_BLOCKED
You've sent an image that is marked in our database as unrecognizable. Usually that happens if the website where you found the captcha stopped sending you captchas and started to send "deny access" image.
Try to override website's limitations.
ERROR_BAD_PARAMETERS
The error code is returned if some required parameters are missing in your request or the values have incorrect format.
Check that your request contains all the required parameters and the values are in proper format.
ERROR_BAD_PROXY
You can get this error code when sending a captcha via proxy server which ismarked as BAD by our API.
Use a different proxy server in your requests.
ERROR_SERVER_ERROR
Something went worng with our server.
Try again after 10 seconds.
ERROR_INTERNAL_SERVER_ERROR
Something went worng with our captcha processing servers.
Try again after 10 seconds.
List of res.php errors
Error code
Description
Action
CAPCHA_NOT_READY
Your captcha is not solved yet.
Make 5 seconds timeout and repeat your request.
ERROR_CAPTCHA_UNSOLVABLE
We are unable to solve your captcha it may be not supported.
Check if supported & you can retry to send your captcha.
ERROR_WRONG_USER_KEY
You've provided key parameter value in incorrect format, it shouldcontain 32 symbols.
You've provided captcha ID in wrong format. The ID can contain numbers only.
Check the ID of captcha or your code that gets the ID.
ERROR_WRONG_CAPTCHA_ID
You've provided incorrect captcha ID.
Check the ID of captcha or your code that gets the ID.
ERROR_EMPTY_ACTION
Action parameter is missing or no value is provided for action parameter.
Check your request parameters and add the neccessary value, e.g. get or getbalance.
ERROR_PROXY_CONNECTION_FAILED
You can get this error code if we were unable to load a captcha through your proxy server. The proxy will be marked as BAD by our API and we will not accept requests with the proxy during 10 minutes. You will recieve ERROR_BAD_PROXY code from in.php API endpoint in such case.
Use a different proxy server in your requests.
ERROR_INTERNAL_SERVER_ERROR
Something went worng with our captcha processing servers.
Try again after 10 seconds.
Secure Checkout
Complete Your Purchase
Review the selected plan and choose how you want to pay.
Loading plan details...
Unable to load plan details. Please try again.
Loading balance payment...
Add Funds
Top up your wallet balance to continue.
$
Payment Methods Supported:
Credit Card, Bitcoin, and other payment methods via secure checkout.